Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Friends | List of all members
ReMutexDirect Class Reference

This class implements a standard reMutex by making direct calls to the underlying implementation layer. More...

`#include "reMutexDirect.h"`

Inheritance diagram for ReMutexDirect:

## Public Member Functions
void | acquire () const
| Grabs the reMutex if it is available.
void | acquire (Thread *current_thread) const
| This variant on acquire() accepts the current thread as a parameter, if it is already known, as an optimization.
void | clear_name ()
| The mutex name is only defined when compiling in DEBUG_THREADS mode.
bool | debug_is_locked () const
| Returns true if the current thread has locked the ReMutex, false otherwise.
void | elevate_lock () const
| This method increments the lock count, assuming the calling thread already holds the lock.
std::string | get_name () const
| The mutex name is only defined when compiling in DEBUG_THREADS mode.
bool | has_name () const
| The mutex name is only defined when compiling in DEBUG_THREADS mode.
void | lock ()
| Alias for acquire() to match C++11 semantics.
void | output (std::ostream &out) const
| This method is declared virtual in MutexDebug, but non-virtual in ReMutexDirect.
void | release () const
| Releases the reMutex.
void | set_name (const std::string &name)
| The mutex name is only defined when compiling in DEBUG_THREADS mode.
bool | try_acquire () const
| Returns immediately, with a true value indicating the mutex has been acquired, and false indicating it has not.
bool | try_acquire (Thread *current_thread) const
| Returns immediately, with a true value indicating the mutex has been acquired, and false indicating it has not.
bool | try_lock ()
| Alias for try_acquire() to match C++11 semantics.
void | unlock ()
| Alias for release() to match C++11 semantics.

## Friends
class | LightReMutexDirect

## Detailed Description

This class implements a standard reMutex by making direct calls to the underlying implementation layer.

It doesn't perform any debugging operations.

Definition at line 29 of file reMutexDirect.h.

## Member Function Documentation

## ◆ acquire() [1/2]

void ReMutexDirect::acquire | ( |  | ) | const
| inline

Grabs the reMutex if it is available.

If it is not available, blocks until it becomes available, then grabs it. In either case, the function does not return until the reMutex is held; you should then call unlock().

This method is considered const so that you can lock and unlock const reMutexes, mainly to allow thread-safe access to otherwise const data.

Also see ReMutexHolder.

Definition at line 81 of file reMutexDirect.I.

Referenced by ReMutexHolder::ReMutexHolder(), ReMutexHolder::ReMutexHolder(), and GeomVertexArrayData::request_resident().

## ◆ acquire() [2/2]

void ReMutexDirect::acquire | ( | Thread * | current_thread | ) | const
| inline

This variant on acquire() accepts the current thread as a parameter, if it is already known, as an optimization.

Definition at line 95 of file reMutexDirect.I.

## ◆ clear_name()

void ReMutexDirect::clear_name | ( |  | ) |
| inline

The mutex name is only defined when compiling in DEBUG_THREADS mode.

Definition at line 191 of file reMutexDirect.I.

## ◆ debug_is_locked()

bool ReMutexDirect::debug_is_locked | ( |  | ) | const
| inline

Returns true if the current thread has locked the ReMutex, false otherwise.

This method is only intended for use in debugging, hence the method name; in the ReMutexDirect case, it always returns true, since there's not a reliable way to determine this otherwise.

Definition at line 176 of file reMutexDirect.I.

## ◆ elevate_lock()

void ReMutexDirect::elevate_lock | ( |  | ) | const
| inline

This method increments the lock count, assuming the calling thread already holds the lock.

After this call, release() will need to be called one additional time to release the lock.

This method really performs the same function as acquire(), but it offers a potential (slight) performance benefit when the calling thread knows that it already holds the lock. It is an error to call this when the calling thread does not hold the lock.

Definition at line 143 of file reMutexDirect.I.

## ◆ get_name()

std::string ReMutexDirect::get_name | ( |  | ) | const
| inline

The mutex name is only defined when compiling in DEBUG_THREADS mode.

Definition at line 206 of file reMutexDirect.I.

## ◆ has_name()

bool ReMutexDirect::has_name | ( |  | ) | const
| inline

The mutex name is only defined when compiling in DEBUG_THREADS mode.

Definition at line 198 of file reMutexDirect.I.

## ◆ lock()

void ReMutexDirect::lock | ( |  | ) |
| inline

Alias for acquire() to match C++11 semantics.

See also
  acquire()

Definition at line 33 of file reMutexDirect.I.

Referenced by PT(), and PT().

## ◆ output()

void ReMutexDirect::output | ( | std::ostream & | out | ) | const

This method is declared virtual in MutexDebug, but non-virtual in ReMutexDirect.

Definition at line 23 of file reMutexDirect.cxx.

## ◆ release()

void ReMutexDirect::release | ( |  | ) | const
| inline

Releases the reMutex.

It is an error to call this if the reMutex was not already locked.

This method is considered const so that you can lock and unlock const reMutexes, mainly to allow thread-safe access to otherwise const data.

Definition at line 160 of file reMutexDirect.I.

Referenced by GeomVertexArrayData::request_resident().

## ◆ set_name()

void ReMutexDirect::set_name | ( | const std::string & | name | ) |
| inline

The mutex name is only defined when compiling in DEBUG_THREADS mode.

Definition at line 184 of file reMutexDirect.I.

## ◆ try_acquire() [1/2]

bool ReMutexDirect::try_acquire | ( |  | ) | const
| inline

Returns immediately, with a true value indicating the mutex has been acquired, and false indicating it has not.

Definition at line 109 of file reMutexDirect.I.

## ◆ try_acquire() [2/2]

bool ReMutexDirect::try_acquire | ( | Thread * | current_thread | ) | const
| inline

Returns immediately, with a true value indicating the mutex has been acquired, and false indicating it has not.

Definition at line 123 of file reMutexDirect.I.

## ◆ try_lock()

bool ReMutexDirect::try_lock | ( |  | ) |
| inline

Alias for try_acquire() to match C++11 semantics.

See also
  try_acquire()

Definition at line 47 of file reMutexDirect.I.

## ◆ unlock()

void ReMutexDirect::unlock | ( |  | ) |
| inline

Alias for release() to match C++11 semantics.

See also
  release()

Definition at line 61 of file reMutexDirect.I.

Referenced by PT(), and PT().

## Friends And Related Symbol Documentation

## ◆ LightReMutexDirect

friend class LightReMutexDirect
| friend

Definition at line 79 of file reMutexDirect.h.

The documentation for this class was generated from the following files:

- panda/src/pipeline/reMutexDirect.h
- panda/src/pipeline/reMutexDirect.cxx
- panda/src/pipeline/reMutexDirect.I